=== debian/changelog ===
cppad (2018.00.00.0-1) unstable; urgency=medium

  * New upstream release
  * Bump policy
  * Bump to debhelper 11
  * Can install nonexistent NEWS file, install not README but readme.md

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 09 Jan 2018 16:10:12 +0000
