=== debian/control ===
Source: cppad
Section: devel
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Miles Lubin <miles.lubin@gmail.com>,
           Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper (>= 11), cmake, libboost-dev
Standards-Version: 4.1.3
Homepage: https://projects.coin-or.org/CppAD/
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/cppad.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=debian-science/packages/cppad.git

Package: cppad
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Automatic Differentiation (AD) of C++ algorithms
 CppAD is a package for automatic differentiation of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains C++ header files and documentation.
