=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_autoreconf:
	@echo "Hey, debhelper 10, what the heck are you doing?"
	@echo "Stop!"
	@echo "Stop it!!"
	@echo "THE BUILD SYSTEM IS CMAKE!!!"

# web documentation uses .xml extension
override_dh_compress:
	dh_compress -X.xml

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog-upstream

override_dh_link:
	cd debian/cppad/usr/share/doc/cppad/doc && \
	if test -e cppad.xml -a \! -e index.xml \
	   || cmp cppad.xml index.xml ; then \
	  echo index.xml missing or identical to cppad.xml && \
	  ln --verbose --symbolic --force cppad.xml index.xml ; \
	fi
	dh_link
